{ ---------------------------------------------- }

 const x_y=4/3; c05=7;

 type ekr=record
  ex0,ex1,ey0,ey1:real;
  x0,x1,y0,y1,z0,z1,f0,f1,dx,dy:real;
  ix0,ix1,iy0,iy1,dix,diy:integer;
  nx,ny,nx_,ny_:integer;
 end;

 function x2i(x:real; e:ekr):integer; var ex:real;
 begin with e do begin
  ex:=ex0+(ex1-ex0)*((x-x0)/dx);
  if ex<ex0 then ex:=ex0; if ex>ex1 then ex:=ex1;
  x2i:=round((ex/x_y)*getmaxx);
 end end;
 function y2j(y:real; e:ekr):integer; var ey:real;
 begin with e do begin
  ey:=ey0+(ey1-ey0)*((y-y0)/dy);
  if ey<ey0 then ey:=ey0; if ey>ey1 then ey:=ey1;
  y2j:=getmaxy-round(ey*getmaxy);
 end end;
 function i2x(i:integer; e:ekr):real; var x:real;
 begin with e do begin x:=x0+dx*(i-ix0)/(ix1-ix0); end; i2x:=x; end;
 function j2y(i:integer; e:ekr):real; var y:real;
 begin with e do begin y:=y0+dy*(i-iy0)/(iy1-iy0); end; j2y:=y; end;

 procedure prisv_ekr(var e:ekr; ea,eb,ec,ed:real; a,b,c,d,ee,f,g,h:real);
  {var ex,ey:real;}
 begin
  if (ea>=eb) or (ec>=ed) then begin
   writeln('Prisv_ekr: ea,eb,ec,ed=',ea:8:4,' ',eb:8:4,' ',ec:8:4,' ',ed:8:4);
   writeln('Treb. ea<eb i ec<ed .'); readln; halt;
  end;
  if (a=b) or (c=d) or (ee=f) or (g=h) then begin
   writeln('Prisv_ekr: treb. a<>b i t.d.'); readln; halt;
  end;
  with e do begin
   ex0:=ea; ex1:=eb; ey0:=ec; ey1:=ed;
   x0:=a; x1:=b; y0:=c; y1:=d; z0:=ee; z1:=f; f0:=g; f1:=h;
   dx:=x1-x0; dy:=y1-y0;
   ix0:=round((ex0/x_y)*getmaxx); ix1:=round((ex1/x_y)*getmaxx);
   dix:=ix1-ix0;
   iy0:=getmaxy-round((ey0)*getmaxy); iy1:=getmaxy-round((ey1)*getmaxy);
   diy:=iy1-iy0;
  end;
 end;
 {Vydel. tekushch. kusok ekrana;
    ey0 i ey1 prinadl. [0,1], a ex0 i ex1 - [0,x_y];
    pri etom, napr., prisv_ekr(e,0.1,0.2,0.1,0.2,...) zadast kvadr. oblast`.
    Yesli nado ispol`z. ves` ekran:
    prisv_ekr(e, 0,x_y,0,1, ...).}

 procedure prisv_ramk(var e:ekr; nxe,nye,nx_e,ny_e:integer);
 begin
  with e do begin nx:=nxe; ny:=nye; nx_:=nx_e; ny_:=ny_e; end;
 end;

 var po_ix,po_iy:integer;
 procedure po(x,f:real; e:ekr; color:integer); var i,j:integer;
 begin
  i:=x2i(x,e); j:=y2j(f,e); putpixel(i,j,color);
  po_ix:=i; po_iy:=j; {chtoby moch` sdelat` nadpis` r`adom s tochkoj}
 end;

 procedure l(x0,y0,x1,y1:real; e:ekr; color:integer);
 {peredelat` - uchest`, chto tochki m.b. za predelami ekrana}
  var i0,j0,i1,j1:integer;
 begin
  i0:=x2i(x0,e); i1:=x2i(x1,e); j0:=y2j(y0,e); j1:=y2j(y1,e);
  setcolor(color); line(i0,j0,i1,j1);
 end;

 procedure ramka(e:ekr); var ix,iy,i,j,p:integer;
 begin with e do begin
  setcolor(c05);
  for iy:=0 to ny*ny_ do begin
   j:=y2j(y0+(iy/(ny*ny_))*dy,e);
   if (iy mod ny_)=0 then line(ix0,j,ix1,j) else begin
    for p:=ix0 to ix1 do if odd(p) then putpixel(p,j,c05);
   end;
  end;
  for ix:=0 to nx*nx_ do begin
   i:=x2i(x0+(ix/(nx*nx_))*dx,e);
   if (ix mod nx_)=0 then line(i,iy0,i,iy1) else begin
    for p:=iy0 downto iy1 do if odd(p) then putpixel(i,p,c05);
   end;
  end;
 end end;
 { ---------------------------------- }
