{$R+}
Program new3; uses graph;
{grafika i peregruzka oper. - spetsif. dlq TMT-pask.!
  Vizualiz. kompl. f-cij kompl. perem.: abs. vel. pered. jarkost`ju,
  faza - tsvetom: zel. - Re, krasn. - Im, s sin. ottenkom - <0.
  Ispol`z. peregruzku arifm. operatorov.
  S'jedanije nizhn. linii ramki - osh. translqtora.
}

{-----------------}
 { $i complsub.pas}

 type complex=record re,im:real; end;

 procedure wy(c:complex); begin write(' ',c.re:8,' ',c.im:8) end;

 procedure csqrt(var a,b:complex); var r,i,rr,fi,tgfi:real;
 begin
  r:=b.re; i:=b.im; rr:=sqrt(sqr(r)+sqr(i));
  if (r=0) and (i=0) then fi:=0; {uslovno}
  if (r=0) and (i>0) then fi:=pi/2;
  if (r=0) and (i<0) then fi:=3*pi/2;
  if (r<>0) then begin
   tgfi:=i/r; fi:=arctan(tgfi);
   if r<0 then fi:=fi+pi; if (i<0) and (r>0) then fi:=fi+2*pi
  end; {eto obyesp.fi=0..2*pi};
  rr:=sqrt(rr); fi:=fi/2; r:=rr*cos(fi); i:=rr*sin(fi);
  if i<0 then begin r:=-r; i:=-i end; a.re:=r; a.im:=i
 end;

 function cabs(c:complex):real; begin cabs:=sqrt(sqr(c.re)+sqr(c.im)) end;

 function arg(b:complex):real; var r,i,fi,tgfi:real;
 begin r:=b.re; i:=b.im;
  if (r=0) and (i=0) then fi:=0; {uslovno}
  if (r=0) and (i>0) then fi:=pi/2;
  if (r=0) and (i<0) then fi:=3*pi/2;
  if (r<>0) then begin
   tgfi:=i/r; fi:=arctan(tgfi);
   if r<0 then fi:=fi+pi; if (i<0) and (r>0) then fi:=fi+2*pi
  end; {eto obyesp.fi=0..2*pi}; arg:=fi
 end;
{--------------------}

 function cmplx(x,y:real):complex;
 with result do begin re:=x; im:=y; end;

 function add_cc(a,b:complex):complex;
 with result do begin re:=a.re+b.re; im:=a.im+b.im; end;
 overload + = add_cc;

 function sub_cc(a,b:complex):complex;
 with result do begin re:=a.re-b.re; im:=a.im-b.im; end;
 overload - = sub_cc;

 function mul_cc(a,b:complex):complex;
 with result do begin re:=a.re*b.re-a.im*b.im; im:=a.re*b.im+b.re*a.im; end;
 overload * = mul_cc;

 function mul_rc(a:real; b:complex):complex;
 with result do begin re:=a*b.re; im:=a*b.im; end;
 overload * = mul_rc;

 function div_cc(a,b:complex):complex; var d:real;
 with result do begin
 begin d:=sqr(b.re)+sqr(b.im);
  if d>0 then begin
   re:=(a.re*b.re+a.im*b.im)/d; im:=(a.im*b.re-a.re*b.im)/d
  end else begin
   re:=0; im:=0; {uslovno}
  end;
 end;
 end;
 overload / = div_cc;

 function cexp(b:complex):complex; var c:real;
 with result do begin c:=exp(b.re); re:=c*cos(b.im); im:=c*sin(b.im); end;
 {overload exp = cexp;}
 function ccos(b:complex):complex; const i:complex=(re:0; im:1);
 begin ccos:=0.5*(cexp(i*b)+cexp(-1*i*b)); end;
 {overload cos = ccos;}
 function csin(b:complex):complex; const i:complex=(re:0; im:1);
 begin csin:=-0.5*i*(cexp(i*b)-cexp(-1*i*b)); end;
 {overload sin = csin;}
 function c_tg(b:complex):complex; const i:complex=(re:0; im:1);
 begin c_tg:=csin(b)/ccos(b); end;

 {$i dupa_gra.pas}

{-------------------}
{sozd. tsvetn. shkaly dlq vizualiz. f-cij kompl. perem.:
  jarkost` peredajot abs. velichinu, a okraska - fazu:
  Re - krasn, Im - zel., no esli Re<0 ili Im<0, dobav. sinij.
}

 var i,j,m,ir,ifi,ix,iy:integer; r_,fi,x,y:real;
 const n_color=32; n_jark=8; {proizv=256}

 function nr(r,fi:real):integer; var ir,ifi:integer;
 begin
  r:=0.5*ln(1+5*r);
  {inogda ln uluchsh. vidimost`, osobenno pol`usov, no koef-ty zhelat. podbir.}
  if r>1 then r:=1;
  ifi:=round(fi/(2*pi)*n_color); if ifi=n_color then ifi:=0;
  ir:=round(r*n_jark); if ir>=n_jark then ir:=n_jark-1;
  nr:=n_jark*ifi+ir;
 end;

 procedure init_color;
  var m,red,green,blue:integer; jark,green_,red_,blue_:real;
 begin
  m:=-1; for i:=0 to n_color-1 do for j:=0 to n_jark-1 do begin m:=m+1;
   jark:=63*j/n_jark;
   green_:=sqr(cos(2*pi*i/n_color));
   red_  :=sqr(sin(2*pi*i/n_color));
   blue_ :=0.5+0.5*cos(2*pi*i/n_color-pi/4+pi);
   green:=round(jark*green_);
   red  :=round(jark*red_);
   blue :=round(jark*blue_);
   SetRGBPalette(m,red,green,blue);
  end;
 end;
 {-------------------------}

 var a,b,cc,d,d1,d2,d3,d4:complex; 
 var e1:ekr;

 procedure izobr(ix,iy:integer; b:complex);
 {b - znach.izuch.f-tsii v tyekushch.tochkye}
 begin
  putpixel(ix,iy,nr(cabs(b),arg(b)));
 end;

 {-----}
 type kfkp=function(z:complex):complex;

 procedure show(f:kfkp; x0e,x1e,y0e,y1e,x0,x1,y0,y1,coef:real);
  const del=0.02;
  var e1:ekr; i,j:integer; z,ff:complex;
 begin
  prisv_ekr(e1, x0e,x1e-del,y0e,y1e-del, x0,x1,y0,y1,0,1,0,1);
  prisv_ramk(e1,2,2,1,1); ramka(e1);
  for i:=e1.ix0 to e1.ix1 do begin z.re:=i2x(i,e1);
  for j:=e1.iy0 downto e1.iy1 do begin z.im:=j2y(j,e1);
   ff:=coef*f(z); izobr(i,j,ff);
  end;
  end;
 end;
 {-----}

 {mnogochl. stepeni 1 - 1 nul`, bez poljusov}
 function f0(z:complex):complex;
 begin f0:=z; end;

 {mnogochl. stepeni 2 - 2 nulq, bez poljusov}
 function f_quadr(z:complex):complex; var b,c:complex;
 begin c:=z*z; f_quadr:=c; end;
 function f_2z(z:complex):complex; var b,c:complex;
 begin b:=cmplx(3,0); c:=(z-b)*(z+b); f_2z:=c; end;
 function f_2z_(z:complex):complex; var b,c:complex;
 begin b:=cmplx(0,3); c:=(z-b)*(z+b); f_2z_:=c; end;

 {mnogochl. stepeni 3 - 3 nulq, bez poljusov}
 function f_cub(z:complex):complex; var b,c:complex;
 begin c:=z*z*z; f_cub:=c; end;
 function f_3z(z:complex):complex; var b1,b2,b3,c:complex; const co=4.0;
 begin
  b1:=cmplx(1,0); b2:=cmplx(-1/2,sqrt(3)/2); b3:=cmplx(-1/2,-sqrt(3)/2);
  b1:=co*b1; b2:=co*b2; b3:=co*b3;
  c:=(z-b1)*(z-b2)*(z-b3); f_3z:=c;
 end;
 function f_3zv(z:complex):complex; var b,c:complex;
 begin b:=cmplx(5,0); c:=(z-b)*(z-b)*(z+b); f_3zv:=c; end;

 {bez nulej, 1 poljus}
 function f_1z(z:complex):complex; var b,c:complex;
 begin b:=cmplx(1,0); c:=b/z; f_1z:=c; end;
 function f_1z_(z:complex):complex; var b,c:complex;
 begin b:=cmplx(0,1); c:=b/z; f_1z_:=c; end;
 {2-kratn. poljus}
 function f_1z2(z:complex):complex; var b:complex;
 begin b:=cmplx(1,0)/z/z; f_1z2:=b; end;

 {1 nul`, 1 poljus}
 function f_1z1p(z:complex):complex; var b,c:complex;
 begin b:=cmplx(2,0); c:=(z-b)/(z+b); f_1z1p:=c; end;
(*
 function f_cexp(z:complex):complex;
 begin f_cexp:=cexp(0.5*z); end;
*)
 function sin3(z:complex):complex;
 begin sin3:=z-(1/6)*z*z*z; end;
 function sin5(z:complex):complex;
 begin sin5:=z-(1/6)*z*z*z+(1/120)*z*z*z*z*z; end;
 function sin7(z:complex):complex; var z3,z5,z7:complex;
 begin
  z3:=z*z*z; z5:=z3*z*z; z7:=z5*z*z;
  sin7:=z-(1/6)*z3+(1/120)*z5-(1/120/6/7)*z7;
 end;

 const pi=3.14159265358; {bez etogo -> "treb. const"}
 const n3=pi*pi; n5=-n3*4*pi*pi; n7=-n5*9*pi*pi; {koef. pri z^1 v sin3_ etc.}

 function sin3_(z:complex):complex; const pi_:complex=(re:pi; im:0);
 begin sin3_:=(1/n3)*z*(z-pi_)*(z+pi_); end;
 function sin5_(z:complex):complex; const pi_:complex=(re:pi; im:0);
 begin sin5_:=(1/n5)*z*(z-pi_)*(z+pi_)*(z-2*pi_)*(z+2*pi_); end;
 function sin7_(z:complex):complex; const pi_:complex=(re:pi; im:0);
 begin
  sin7_:=(1/n7)*z*(z-pi_)*(z+pi_)*(z-2*pi_)*(z+2*pi_)*(z-3*pi_)*(z+3*pi_);
 end;


 function lorentz(z:complex):complex; var b,z_:complex;
 begin b:=cmplx(2,0); z_:=(1/3)*z; lorentz:=b/(b+z_*z_); end;
 function gauss(z:complex):complex; var b,z_:complex;
 begin b:=cmplx(2,0); z_:=(1/3)*z; gauss:=b*cexp(-1*z_*z_); end;

 function sin_m1(z:complex):complex; var b,z_:complex;
 begin sin_m1:=cmplx(1,0)/csin(z); end;

 const pr=10.0;

Begin
 SetSVGAMode(640,480,8,LfbOrBanked);
 init_color;

 show(f0,      0,  0.2,0.8,1.0, -pr,pr,-pr,pr, 0.1);
 show(f_quadr, 0.2,0.4,0.8,1.0, -pr,pr,-pr,pr, 0.02);
 show(f_2z,    0.4,0.6,0.8,1.0, -pr,pr,-pr,pr, 0.02);
 show(f_2z_,   0.6,0.8,0.8,1.0, -pr,pr,-pr,pr, 0.02);

 show(f_cub,   0.8,1.0,0.8,1.0, -pr,pr,-pr,pr, 0.005);
 show(f_3z,    1.0,1.2,0.8,1.0, -pr,pr,-pr,pr, 0.005);
 show(f_3zv,   0.0,0.2,0.6,0.8, -pr,pr,-pr,pr, 0.005);

 show(f_1z,    0.2,0.4,0.6,0.8, -pr,pr,-pr,pr, 2.0);
 show(f_1z_,   0.4,0.6,0.6,0.8, -pr,pr,-pr,pr, 2.0);

 show(f_1z1p,  0.6,0.8,0.6,0.8, -pr,pr,-pr,pr, 0.5);

 show(cexp,    0.8,1.0,0.6,0.8, -pr,pr,-pr,pr, 1);
 show(csin,    1.0,1.2,0.6,0.8, -pr,pr,-pr,pr, 1);
 show(ccos,    0.0,0.2,0.4,0.6, -pr,pr,-pr,pr, 1);
 show(c_tg,    0.2,0.4,0.4,0.6, -pr,pr,-pr,pr, 1);

 show(sin3,    0.4,0.6,0.4,0.6, -pr,pr,-pr,pr, 1);
 show(sin5,    0.6,0.8,0.4,0.6, -pr,pr,-pr,pr, 1);
 show(sin7,    0.8,1.0,0.4,0.6, -pr,pr,-pr,pr, 1);
 show(sin3_,   1.0,1.2,0.4,0.6, -pr,pr,-pr,pr, 1);
 show(sin5_,   0.0,0.2,0.2,0.4, -pr,pr,-pr,pr, 1);
 show(sin7_,   0.2,0.4,0.2,0.4, -pr,pr,-pr,pr, 1);

 show(lorentz, 0.4,0.6,0.2,0.4, -pr,pr,-pr,pr, 1);
 show(gauss,   0.6,0.8,0.2,0.4, -pr,pr,-pr,pr, 1);

 show(sin_m1,  0.8,1.0,0.2,0.4, -pr,pr,-pr,pr, 5);
 show(f_1z2,   1.0,1.2,0.2,0.4, -pr,pr,-pr,pr, 5);

 readln; restoreCRTmode;
End.
